<template>
  <div class="page">
    <div
      v-if="
        routeFrom &&
        (
          routeFrom.name === 'SphereDetail' ||
          routeFrom.name === 'GroupDetail' ||
          routeFrom.name === 'OrganisationDetail' ||
          routeFrom.name === 'Accounts'
        )
      "
      class="back-link"
      @click="$router.push(routeFrom)"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span v-if="routeFrom.name === 'SphereDetail'">
        Groupe d'organisations
      </span>
      <span v-else-if="routeFrom.name === 'GroupDetail'">
        Groupe d'utilisateurs
      </span>
      <span v-if="routeFrom.name === 'OrganisationDetail'">
        Organisation
      </span>
      <span v-if="routeFrom.name === 'Accounts'">
        Gestion des comptes
      </span>
    </div>
    <div
      v-else
      class="back-link"
      @click="$router.push({ name: 'Users' })"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Liste des utilisateurs
      </span>
    </div>
    <b-container fluid>
      <b-overlay
        v-if="loading"
        id="overlay-background"
        :show="loading"
        :variant="'white'"
        :opacity="0.7"
        :blur="'2px'"
        rounded="sm"
        no-wrap
      >
      </b-overlay>
      <b-row v-else>
        <b-col
          cols="8"
          class="detail-form"
          style="overflow-x: hidden;"
        >
          <h2 v-if="currentUser">{{ currentUser.last_name }} {{ currentUser.first_name }}</h2>
          <UserForm
            :user="currentUser"
            :roles="currentUserRoles"
            :loading="userDataLoading"
            @save="saveUser"
            @delete="deletingUser = true"
          />
        </b-col>
        <b-col
          cols="4"
          class="detail-card"
        >
          <UserCard
            :user="currentUser"
          />
        </b-col>
      </b-row>
    </b-container>
    <DeleteUser
      :open="deletingUser"
      :user="currentUser"
      @hide="deletingUser = false; $router.push({ name: 'Users' });"
    />
  </div>
</template>

<script>
import UserForm from '@/components/Forms/UserForm.vue';
import UserCard from '@/components/Cards/UserCard.vue';
import DeleteUser from '@/components/Modals/DeleteUser.vue';

import { mapState, mapActions } from 'vuex';

export default {
  name: 'UserDetail',

  components: {
    UserForm,
    UserCard,
    DeleteUser
  },

  data() {
    return {
      loading: true,
      userDataLoading: false,
      routeFrom: null,
      deletingUser: false
    };
  },

  computed: {
    ...mapState('users', [
      'currentUser',
      'currentUserRoles'
    ])
  },

  beforeRouteEnter(to, from, next) {
    next((vm) => {
        vm.routeFrom = from;
    });
  },

  created() {
    this.loading = true;
    this.GET_USER_DETAIL(this.$route.params.id)
      .then(() => {
        this.loading = false;
      });
  },

  mounted() {
    // Watch modal closing event
    this.$root.$on('bv::modal::hide', () => {
      this.deletingUser = false
    });
  },

  methods: {
    ...mapActions('users', [
      'GET_USER_DETAIL',
      'GET_USERS_LIST',
      'UPDATE_USER'
    ]),
    ...mapActions('organisations', [
      'GET_ORGANISATIONS_LIST'
    ]),

    saveUser(data) {
      this.userDataLoading = true;
      this.UPDATE_USER({
        id: this.currentUser.id,
        data: data
      }).then(() => {
        Promise.all([
          this.GET_USER_DETAIL(this.$route.params.id),
          this.GET_USERS_LIST({
            direction: null,
            field: null
          }),
          this.GET_ORGANISATIONS_LIST({
            direction: null,
            field: null
          })
        ]).then(() => {
          this.userDataLoading = false;
        });
      });
    }
  }
}
</script>

<style lang="less" scoped>

.container-fluid {
  margin: 1em;
  width: calc(100% - 2em);
}

.detail-form {
  padding-bottom: 200px;
  margin-bottom: - 200px;
}
</style>
